<?php
/*
  $Id$

  CE Phoenix, E-Commerce made Easy
  https://phoenixcart.org

  Copyright (c) 2021 Phoenix Cart

  Released under the GNU General Public License
*/
?>

<div class="alert alert-info" role="alert">
  <h1>Bienvenue à CE Phoenix</h1>

  <p>CE Phoenix vous aide à vendre les produits au monde entier avec votre propre boutique en ligne. Son outil d'Administration Tool gère les produits, customers, les commandes, les newsletters, les promotions, et encore plus pour assurer le succès de votre boutique en ligne.</p>
  <p>Phoenix a attiré une grande communauté de commerçants et programmeurs qui se soutiennent et qui ont fourni des milliers de contributions gratuites et payantes pour augmenter les fonctionnalités et le potentiel de votre boutique en ligne.</p>
</div>

<div class="row">
  <div class="col-sm-12 col-md-9 order-last">

    <h1 class="dislay-4">Phoenix v<?php echo osc_get_version(); ?> Installation</h1>

<?php
    $configfile_array = [];

    if (file_exists(osc_realpath(dirname(__FILE__) . '/../../../includes') . '/configure.php') && !osc_is_writable(osc_realpath(dirname(__FILE__) . '/../../../includes') . '/configure.php')) {
      @chmod(osc_realpath(dirname(__FILE__) . '/../../../includes') . '/configure.php', 0777);
    }

    if (file_exists(osc_realpath(dirname(__FILE__) . '/../../../admin/includes') . '/configure.php') && !osc_is_writable(osc_realpath(dirname(__FILE__) . '/../../../admin/includes') . '/configure.php')) {
      @chmod(osc_realpath(dirname(__FILE__) . '/../../../admin/includes') . '/configure.php', 0777);
    }

    if (file_exists(osc_realpath(dirname(__FILE__) . '/../../../includes') . '/configure.php') && !osc_is_writable(osc_realpath(dirname(__FILE__) . '/../../../includes') . '/configure.php')) {
      $configfile_array[] = osc_realpath(dirname(__FILE__) . '/../../../includes') . '/configure.php';
    }

    if (file_exists(osc_realpath(dirname(__FILE__) . '/../../../admin/includes') . '/configure.php') && !osc_is_writable(osc_realpath(dirname(__FILE__) . '/../../../admin/includes') . '/configure.php')) {
      $configfile_array[] = osc_realpath(dirname(__FILE__) . '/../../../admin/includes') . '/configure.php';
    }

    $error_array = [];
    $warning_array = [];

    if (!extension_loaded('mysqli')) {
      $error_array['mysql'] = 'L\'extension MySQLi est réquise mais pas installée. Veuillez activer l\'extension pour continuer l\'installation.';
    }

    $php_version_thumb = '<i class="fas fa-thumbs-up text-success"></i>';

    if (version_compare(PHP_VERSION, PHP_VERSION_MIN, '<')) {
      $error_array['php_version'] = sprintf('La version of PHP doit être au moins <strong>%s</strong>.  La version ici est %s.', PHP_VERSION_MIN, PHP_VERSION);
      $php_version_thumb = '<i class="fas fa-thumbs-down text-danger"></i>';
    }
    
    if (version_compare(PHP_VERSION, PHP_VERSION_MAX, '>=')) {
      $warning_array['php_version'] = sprintf('Performance sur les versions supérieures à <strong>%s</strong> n\'a pas été vérifiée. La version ici est %s.', PHP_VERSION_MAX, PHP_VERSION);
      $php_version_thumb = '<i class="fas fa-thumbs-up text-warning"></i>';
    }
    
    if ((int)ini_get('allow_url_fopen') == 0) {
      $warning_array['allow_url_fopen'] = 'Fopen Wrappers doit être activé.  Ceci est un réglage <em>d\'hébergement</em> que vous ou votre hébergeur seront capable à changer en réglant allow_url_fopen sur "1" ou "On" dans le php.ini';
    }
    
    if (!extension_loaded('cURL')) {
      $warning_array['curl'] = 'cURL doit être activé. Ceci est un réglage <em>d\'hébergement</em> que vous ou votre hébergeur seront capable à activer.';
    }

    if (!empty($configfile_array) || !empty($error_array) || !empty($warning_array)) {
        ?>
        
        <table class="table table-condensed table-striped">
          <?php
          if (!empty($error_array)) {
            foreach ( $error_array as $key => $value ) {
              echo '<tr class="table-danger">';
                echo '<th>' . $key . '</th>';
                echo '<td>' . $value . '</td>';
              echo '</tr>';
            }
          }
          if (!empty($warning_array)) {
            foreach ( $warning_array as $key => $value ) {
              echo '<tr class="table-warning">';
                echo '<th>' . $key . '</th>';
                echo '<td>' . $value . '</td>';
              echo '</tr>';
            }
          }
          ?>
        </table>
<?php

      if (!empty($configfile_array)) {
?>

        <div class="alert alert-danger" role="alert">
          <p>Le serveur web ne peut pas sauvegarder les paramètres de l'installation sur les fichiers de configuration.</p>
          <p>Les fichiers suivants ont besoin que leurs permissions d'écriture soient définies à inscriptible (chmod 777):</p>
          <p>

<?php
        echo implode("<br>\n", $configfile_array);
?>

          </p>
        </div>

<?php
      }
    }

    if (!empty($configfile_array) || !empty($error_array)) {
?>

      

<?php
      if (!empty($error_array)) {
        echo '<div class="alert alert-info" role="alert"><i>Changer les paramètres de configuration du serveur web pourrait demander à ce que le service du serveur web soit redémarré avant que les changements soient opérationnels.</i></div>' . "\n";
      }
?>

      <p><a href="index.php" class="btn btn-danger btn-block" role="button">Réessayer</a></p>

<?php
    } else {
?>

      <div class="alert alert-success" role="alert">L'environment du serveur web à été vérifié pour procéder avec succès l'installation et la configuration de votre boutique en ligne.</div>

      <div id="jsOn" style="display: none;">
        <p><a href="install.php" class="btn btn-success btn-block" role="button">Démarrer le processus d'installation</a></p>
      </div>

      <div id="jsOff">
        <p class="text-danger">Veuillez activer le Javascript dans votre navigateur pour démarrer le processus d'installation.</p>
        <p><a href="index.php" class="btn btn-danger btn-block" role="button">Réessayer</a></p>
      </div>

<script>
$(function() {
  $('#jsOff').hide();
  $('#jsOn').show();
});
</script>

<?php
  }
?>
  </div>
  <div class="col-sm-12 col-md-3 order-first">
    <h4>Fonctionnalités Serveur</h4>

    <table class="table table-condensed table-striped">
      <tr>
        <th colspan="3">Version PHP</th>
      </tr>
      <tr>
        <th><?php echo implode('.', [PHP_MAJOR_VERSION, PHP_MINOR_VERSION, PHP_RELEASE_VERSION]); ?></th>
        <td colspan="2" class="text-right"><?php echo $php_version_thumb; ?></td>
      </tr>
<?php
  if (function_exists('ini_get')) {
?>
      <tr>
        <th colspan="3">Réglages PHP</th>
      </tr>
      <tr>
        <th>file_uploads</th>
        <td class="text-right"><?php echo (((int)ini_get('file_uploads') == 0) ? 'Off' : 'On'); ?></td>
        <td class="text-right"><?php echo (((int)ini_get('file_uploads') == 1) ? '<i class="fas fa-thumbs-up text-success"></i>' : '<i class="fas fa-thumbs-down text-danger"></i>'); ?></td>
      </tr>
      <tr>
        <th>auto_start</th>
        <td class="text-right"><?php echo (((int)ini_get('session.auto_start') == 0) ? 'Off' : 'On'); ?></td>
        <td class="text-right"><?php echo (((int)ini_get('session.auto_start') == 0) ? '<i class="fas fa-thumbs-up text-success"></i>' : '<i class="fas fa-thumbs-down text-danger"></i>'); ?></td>
      </tr>
      <tr>
        <th>use_trans_sid</th>
        <td class="text-right"><?php echo (((int)ini_get('session.use_trans_sid') == 0) ? 'Off' : 'On'); ?></td>
        <td class="text-right"><?php echo (((int)ini_get('session.use_trans_sid') == 0) ? '<i class="fas fa-thumbs-up text-success"></i>' : '<i class="fas fa-thumbs-down text-danger"></i>'); ?></td>
      </tr>
      <tr>
        <th colspan="3">Extensions Réquises</th>
      </tr>
      <tr>
        <th>MySQL<?php echo extension_loaded('mysqli') ? 'i' : ''; ?></th>
        <td colspan="2" class="text-right"><?php echo (extension_loaded('mysqli') ? '<i class="fas fa-thumbs-up text-success"></i>' : '<i class="fas fa-thumbs-down text-danger"></i>'); ?></td>
      </tr>
      <tr>
        <th>allow_url_fopen</th>
        <td class="text-right"><?php echo (((int)ini_get('allow_url_fopen') == 0) ? 'Off' : 'On'); ?></td>
        <td class="text-right"><?php echo (((int)ini_get('allow_url_fopen') == 1) ? '<i class="fas fa-thumbs-up text-success"></i>' : '<i class="fas fa-thumbs-down text-danger"></i>'); ?></td>
      </tr>
      <tr>
        <th colspan="3">Extensions Conseillées</th>
      </tr>
      <tr>
        <th>GD</th>
        <td colspan="2" class="text-right"><?php echo (extension_loaded('gd') ? '<i class="fas fa-thumbs-up text-success"></i>' : '<i class="fas fa-thumbs-down text-warning"></i>'); ?></td>
      </tr>
      <tr>
        <th>cURL</th>
        <td colspan="2" class="text-right"><?php echo (extension_loaded('curl') ? '<i class="fas fa-thumbs-up text-success"></i>' : '<i class="fas fa-thumbs-down text-warning"></i>'); ?></td>
      </tr>
      <tr>
        <th>OpenSSL</th>
        <td colspan="2" class="text-right"><?php echo (extension_loaded('openssl') ? '<i class="fas fa-thumbs-up text-success"></i>' : '<i class="fas fa-thumbs-down text-warning"></i>'); ?></td>
      </tr>
    </table>
<?php
  }
?>
  </div>
</div>
